class Sinbotra::Bot
  class RedisStore
    def get(id)
      res = $redis.get(make_key(id))
      Marshal.load(res) unless res.nil?
    end
    alias_method :[], :get

    def set(id, obj)
      raw = Marshal.dump(obj)
      $redis.set(make_key(id), raw)
    end
    alias_method :[]=, :set

    def make_key(id)
      raise NotImplementedError, "make_key needs to be implemented by children"
    end
  end
end

