class Sinbotra::Bot
  class UserRepo
    class << self
      def connect(store=UserStore.new)
        @users ||= store
      end

      def find_or_create(id)
        user = @users[id]
        if user.nil?
          user = create(id)
        end
        user
      end

      def create(id)
        user = Sinbotra::Bot::User.new(id)
        update(user)
        user
      end

      def next_step!(user)
        step = user.conversation.step + 1
        update_conversation(user, user.conversation.id, step)
      end

      def start_conversation(user_id, convo_id)
        user = find_or_create(user_id)
        user = update_conversation(user: user, convo_id: convo_id, step: 0)
        user
      end

      def update_conversation(user:, convo_id:, step:)
        user.update_conversation(convo_id, step)
        update(user)
        user
      end

      def update(user)
        @users[user.id] = user
      end

      def messages(id)
        # Get messages from message store
        $logger.debug("WIP user messages retrieval")
      end
    end
  end
end
