class Sinbotra::MessageHandler
  class << self
    attr_reader :handlers

    def add_handler(provider, handler)
      @handlers ||= {}
      @handlers[provider] = handler
    end
  end

  attr_reader :provider

  def initialize(provider, async=true)
    @provider = provider
    @is_async = async
  end

  def receive_messages(messages)
    messages.each do |msg|
      bot = handler_class.new(msg)
      bot.respond
    end
  end

  def handler_class; self.class.handlers[@provider]; end
end
