require "json"

module Sinbotra
  class MessageStore
    def self.log_in_message!(provider, message, sender)
      timestamp = Time.now
      m = { sender: :user, timestamp: timestamp.to_i, message: message.to_json}.to_json
      $redis.lpush(key(provider, sender.id), m)
    end

    def self.log_out_message!(provider, message, receiver)
      timestamp = Time.now
      m = { sender: :bot, timestamp: timestamp.to_i, message: message.to_json}.to_json
      $redis.lpush(key(provider, receiver.id), m)
    end

    def self.key(provider, user_id)
      ["sinbotra", "messages", user_id.to_s, provider].join(":")
    end
  end
end
