module Sinbotra::Messenger
  class Message
    class Base < Struct
      def postback; respond_to?(:_postback) ? _postback : nil; end
      def text;     respond_to?(:_text)     ? _text     : nil; end
    end

    Sender     = Base.new(:id)
    Text       = Base.new(:id, :timestamp, :sender, :_text)
    Image      = Base.new(:id, :timestamp, :sender, :url, :sticker_id)
    Video      = Base.new(:id, :timestamp, :sender, :url)
    Audio      = Base.new(:id, :timestamp, :sender, :url)
    File       = Base.new(:id, :timestamp, :sender, :url)
    Location   = Base.new(:id, :timestamp, :sender, :url, :lat, :lng)
    QuickReply = Base.new(:id, :timestamp, :sender, :_postback, :_text)
    Postback   = Base.new(:timestamp, :sender, :_postback)
  end
end
