module Sinbotra::Messenger
  class UserPresenter
    attr_reader :current_user

    def initialize(sender)
      @current_user = Sinbotra::Bot::UserRepo.find_or_create(sender.id)
    end

    def id; current_user.id; end

    def conversation
      @current_user.conversation
    end

    def in_conversation?
      !current_conversation.nil?
    end

    def start_conversation(convo_id)
      update_conversation(convo_id, 0)
    end

    def next_step!
      convo = current_user.conversation
      id, step = convo.id, convo.step + 1
      update_conversation(id, step)
    end

    def update_conversation(convo_id, step)
      Sinbotra::Bot::UserRepo.update_conversation(
        user:     current_user,
        convo_id: convo_id,
        step:     step
      )
    end

    def end_conversation!
      current_user.end_conversation
      Sinbotra::Bot::UserRepo.update(current_user)
    end

    def current_conversation
      current_user.conversation
    end
  end
end
